package Cpanel::DNSmeapi;

use strict;
use HTTP::Date;
use XML::Simple ();
use JSON::Syck;
##use Data::Dumper;
BEGIN{
	push @INC, '/usr/local/cpanel/3rdparty/perl/514/lib64/perl5/cpanel_lib','/usr/local/cpanel/3rdparty/perl/514/lib64/perl5/5.14.3/';
}

use Cpanel::SafeFile ();
use Cpanel::FileUtils::TouchFile ();
use Cpanel::Logger ();
##use Cpanel::ExpVar ();

#use Cpanel;
use vars qw/$use_external_hmac $apiurl $db_file $debug $logger $format $outformat $curl/;

BEGIN{
	##unshift @INC, '/usr/local/cpanel/perl';
	$curl='/usr/bin/curl';
	### if the ssl does not work, use the below options
	$curl='/usr/bin/curl -k';
	$format = 'application/xml';
	$format = 'application/json';
	$outformat='application/json';



	$use_external_hmac=0;
	$apiurl='https://api.dnsmadeeasy.com/V2.0';
	$db_file='/var/cpanel/dnsmeapi.db';
	$logger = Cpanel::Logger->new();

	$debug='';#9';
	#$debug='returned_status';

	$use_external_hmac=1;

#	eval{
#		require "Digest/HMAC_SHA1.pm"
#	};
#	if($@){
#		$use_external_hmac=1;
#
#	}else{
#		$use_external_hmac=1;
#	#use Digest::HMAC_SHA1 qw(hmac_sha1_hex);
#
#	}


};

sub _update_named_conf2{
### update the named.conf file for secondary dns usage
	my($domain)=@_;

	 my $result = Cpanel::Wrap::send_cpwrapd_request(
        'namespace' => 'DNSmeapiNS',
        'module'    => 'DNSmeapiAdmin',
        'function'  => 'addzone',
        'data'      => $domain
    );

    if ( $result->{'error'} ) {
        return "Error code $result->{'exit_code'} returned: $result->{'data'}";
    }
    elsif ( ref( $result->{'data'} ) ) {
        return Data::Dumper::Dumper( $result->{'data'} );
    }
    elsif ( defined( $result->{'data'} ) ) {
        return $result->{'data'};
    }
    return 'cpwrapd request failed: ' . $result->{'statusmsg'};

}



sub _update_named_conf{
### update the named.conf file for secondary dns usage
	my($domain)=@_;
	
	#	parse the template with this domain
	use Cpanel::Template;
	my $domain_zone= Cpanel::Template::process_template(
        'cpanel',
        {
            'template_file' => '/usr/local/cpanel/base/frontend/x3/dnsmeapi/named_domain_zone.tmpl',
#            'data'          => { 'domain' => $domain },
	    'domain'	=> $domain,
        },
    );	
	#	
	#	get the /etc/named.conf out to see if the domain is there
	#	if it is not there add that section to
	my $db_file = "/etc/named.conf";
	### backup
	`cp $db_file $db_file.dnsmeapi`;
my $ulock = Cpanel::SafeFile::safeopen(\*DB, "+<",$db_file);
	unless($ulock){
		$logger->die("Could not open $db_file for writing. Reason:" . $! );

	}
	seek(DB,0,0);
	my $output="";
	{
		local $/;
		$output=<DB>;
	}
	print STDERR "Replace for donain: $domain" if $debug;

	unless($output=~ /zone\s+"\Q$domain\E"/si){ 
		$output=~ s#(\};\s*)$#$$domain_zone\n};#sg;	
	}else{

#	### replace just exteral part
	$output=~ s{(view\s*"external")(.*)$}{
		my($part,$part2)=($1,$2);
		my $out="$part";

		if($part2=~ s/zone\s*"\Q$domain\E"\s*\{\s*type\s*master;\n\s*file\s*"\/var\/named\/\Q$domain\E\.db";\n\s*\};\n/$$domain_zone/sgi){
		}else{
		   $part2=~ s/(\};\s*)$/$$domain_zone$1/sg;
		}
		print STDERR "\npart2:$part2\n" if $debug;

		$out.=$part2;
		$out;
	}eisg;
	}

	#$output.="\ndomain:$domain";

	seek(DB,0,0);
	print DB $output;
	truncate (DB, tell(DB));
	##close($fh);
	Cpanel::SafeFile::safeclose( \*DB, $ulock );

}

sub _error{
	$Cpanel::CPERROR{'dnsmeapi'} = join("\n", @_,caller);
}

###############################################################################
## API2 Setup
###############################################################################
# NOTE: the docs state you must provide a detailed hashref, but that is not
#  necessary except in rare cases. You can return an empty hashref and the API
#  engine will assume reasonable defaults, namely that an inbound request like
#  "module=CustomModuleExample&func=foobar' will invoke the 'api2_foobar'
#   subroutine. This shorthand is available in cPanel 11.28+
sub api2 {
    my ($func) = @_;
    my $api_ref = _get_api2_ref();
    return $api_ref->{$func};
}

# Note: In this example we separate the hashref from the api2() dispatch
#  method.  The only advantage is testibility in your unit tests
sub _get_api2_ref {
    my $api_ref = {
        'getKeys'   => {},
        'storeKeys' => {},
		'getDomain' => {},
		'delDomain'	=> {},
		'addDomain'	=> {func => 'api2_addDomain', engine => 'hasharray'},
		'domainRecords'	=> {},
		'getTemplate'	=> {},
		'getVanity'	=> {},
		'addSOA'	=> {},
		'addACL'	=> {},
		'getSecFolder'	=> {},
		'getDomainStuff'	=> {},
		'adddomainRecords'	=> {},

    };
    return $api_ref;
}
sub api2_getKeys{
	### where to get its file
	my(%opts)=@_;
	my $user = $opts{user}?$opts{user}:$Cpanel::user;


	my %keys=();

	my $pfn = $db_file;###"$dir/dnsmeapi.properties";
#_error "file $pfn";
#return \%keys;
#print "$pfn vs $user" if $debug;
#return;


	if (! -e $pfn) {
			return \%keys;
			#_error( "Property file " . $pfn . " not found");

	}
	open my $fh, '<', $pfn
			or _error(  "Unable to open " . $pfn . "Reason:" . $!);


	foreach(<$fh>){


		unless(/^\Q$user\E\|/){
			###$output.=$_;
			next;
		}

		chomp;
		my @data = split(/\|/,$_);
		$keys{apiKey}=$data[1];
		$keys{secretKey}=$data[2];
		$keys{apiURL}=$data[3];
		last;
	}
	close($fh);
	#_debug([\%keys,$user])  if $debug eq 'debug';
	return \%keys;
	##return {apiKey => $apiKey, secretkey => $secretKey};

}

sub api2_storeKeys{
	### where to get its file
	my(%opts)=@_;
	my($dir,$apiKey,$secretKey);
	$dir =  $opts{usertheme}?$opts{usertheme}:"x3";

	$apiKey = $opts{apiKey};
	$secretKey = $opts{secretKey};

	unless(-e $db_file){
		Cpanel::FileUtils::TouchFile::touchfile($db_file) or $logger->warn("Could not create file");
	}


	###my($dir)=@_;
	my $pfn = $db_file;##"$dir/dnsmeapi.properties";
#print "$pfn vs $user\n";
#	if (! -f $pfn) {
#		_error( "Property file " . $pfn . " not found");
#	}
	my $user = $opts{user}?$opts{user}:$Cpanel::user;
#print $user . $pfn if $debug;
#return;

##	open my $fh, '+>', $pfn
#
##		or _error(  "Unable to open " . $pfn . "Reason:" . $!);
##	flock($fh,2);
	my $ulock = Cpanel::SafeFile::safeopen(\*DB, "+<",$db_file);
	unless($ulock){
		$logger->die("Could not open $db_file for writing. Reason:" . $! );

	}
	seek(DB,0,0);
	my $output="";
	my $f =0;
	foreach(<DB>){
		unless(/^\Q$user\E\|/){
			$output.=$_;
			next;
		}
		chomp;
		my @data = split(/\|/,$_);
		$data[1]=$opts{apiKey};
		$data[2]=$opts{secretKey};
		$data[3]=$opts{apiURL};
		$output.=join('|',@data) . "\n";
		$f++;
	}

	seek(DB,0,0);
	unless($f){
		$output.="$user|$opts{apiKey}|$opts{secretKey}|$opts{apiURL}\n";
	}
	_debug([$f,$output]) if $debug eq 'debug';

	print DB $output;
	truncate (DB, tell(DB));
	##close($fh);
	Cpanel::SafeFile::safeclose( \*DB, $ulock );
#	print $fh qq|apiKey=$opts{apiKey}\n|
#	print $fh qq|secretKey=$opts{secretKey}\n|
#	print $fh qq|apiURL=$opts{apiURL}\n|

	return {apiKey => $apiKey, secretkey => $secretKey};
}

sub api2_getDomain{

	my (%opts)=@_;
	my $domainid = $opts{id};
	my @commands=();
	##my $api = api2_getKeys();
	###print "Domain id: $id";
	##_debug(\%opts);
	my $path = $opts{path} ? $opts{path}: 'managed';
	push(@commands,"/dns/$path/$domainid", '-H accept:' . $format);

	my $rs= &_do_request(\@commands);
#	_debug($rs);
#	my @rows=();
#	if(exists $rs->{totalRecords} && $rs->{totalRecords} < 2){
#		push(@rows,$rs->{data});
#	}else{
#		my $recs = $rs->{data};
#		foreach(keys %{$recs}){
#			my $rec = $recs->{$_};
#			$rec->{name}=$_;
#			push(@rows,$rec);
#		}
#	}

	#$rs->{data}=\@rows;
	#_debug($rs);
	return $rs;

}

sub _debug{
	use Data::Dumper;
	print Data::Dumper->Dump([@_]);

}
sub _debug2{
	use Data::Dumper;


	open(my $fh,">/tmp/dnsmeap.error");
		print $fh Data::Dumper->Dump([@_]);
	close($fh);
}

sub api2_getDomainStuff{

	my %opts = @_;
	my @commands=();
	my $stuff = $opts{path};
	if($stuff eq 'ipSet'){

		$stuff="secondary/$stuff";
	}
	my $path='/dns/' . $stuff;

	if($stuff eq 'folder'){
		$path='/security/folder';
	}
	if($opts{id}){
		$path.="/$opts{id}";

	}
#	unless($path=~ /ipSet/){
#		$path.="/";
#	}
	push(@commands,"$path", '-H accept:' . $format);
	#print join " ", @commands;
	my $rs= _do_request(\@commands, {no_result => ''});
	return $rs->{data} if exists $rs->{data};
	#_debug($rs);
	return $rs;

}

sub api2_getTemplate {
	my %opts = @_;
	my @commands=();
	push(@commands,'/dns/template/', '-H accept:' . $format);
	my $rs= _do_request(\@commands, {no_result => 1});
	#_debug($rs);
	return $rs;


}

sub api2_adddomainRecords{

	my(%opts)=@_;
	my @commands=();

	my %in = %Cpanel::FORM;
	my  $path = "/dns/managed/$in{id}/records";

	if($in{sourceId}){

		$path = "/dns/managed/$in{sourceId}/records";
		if($in{sourceId} < 100000){
			$path = "/dns/template/$in{sourceId}/records";
		}
	}
	###_debug(\%Cpanel::FORM);return;
	my %post=(name => $in{typename}, id => $in{typeid}, type => $in{type}, password => '');
	if(exists $in{typeid} && $in{typeid}){
		### edit

		##dns/template/10956/records/9963100
		##$path.=$in{id};
		###$path = "/dns/template/$in{sourceId}/records/$in{typeid}";
		$path.= "/$in{typeid}";

		push(@commands,$path);
		push(@commands,"-X PUT");

	}else{
		### add

		push(@commands,$path);
		push(@commands,"-X POST");

	}

	foreach(qw/value ttl/){
		$post{$_}=$in{$_};
	}
	### some optionnal field based on each xx records
	### for A
	if(exists $in{dynamicDns}){
		$post{dynamicDns}= 'true';
	}
	## for mx mxLevel
	if(exists $in{mxLevel}){
		$post{mxLevel}= $in{mxLevel};
	}
	### addtional fiedls
	foreach(qw/mxLevel priority weight port title keywords description/){
		$post{$_}=$in{$_} if exists $in{$_};
	}



	push(@commands, '-H accept:' . $format);
	push(@commands,"-H content-type:$outformat");
	my $json =  _parse_data_out(\%post,$format) ;
	push(@commands,"-d '$json'");
	#print join("<br>",@commands);##return;
	my $rs= _do_request(\@commands, {no_result => ''});
	#_debug($rs);
	return $rs;

}
sub api2_addSOA {
	my(%opts)=@_;
	my @commands=();
	my $path = $opts{path}?$opts{path}:'soa';
	my $path = "/dns/$path/";
	my %in = %Cpanel::FORM;
	delete $in{submit};
	###_debug(\%Cpanel::FORM);return;
	my %post=();
	my $action = uc($opts{method});
	if(exists $in{id} && $in{id}){
		### edit
		$path.=$in{id};
		push(@commands,$path);
		##push(@commands,"-X PUT");
		$action='PUT' unless $action;

	}else{
		### add

		push(@commands,$path);
		#push(@commands,"-X POST");
		$action='POST' unless $action;

	}
	push(@commands,"-X $action");

	push(@commands, '-H accept:' . $format);
	push(@commands,"-H content-type:$outformat");

	### process ips
	if(exists $in{ips}){

		$in{ips}=~ s/[\r\n]//sg;
		my @ips = split(/,/,$in{ips});
		$in{ips}=\@ips;
	}

	delete $in{type};

	my $json =  _parse_data_out(\%in,$format) ;
	push(@commands,"-d '$json'");
	#print join("<br>",@commands);##return;
	my $rs= _do_request(\@commands, {no_result => ''});
	##_debug($rs);
	return $rs;


}

sub api2_getZoneAcl {
	my %opts = @_;
	my @commands=();
	push(@commands,'/dns/transferAcl', '-H accept:' . $format);
	my $rs= _do_request(\@commands, {no_result => 1});
	###_debug($rs);
	return $rs;
##dns/transferAcl

}
sub api2_getSecFolder {
	my %opts = @_;
	my @commands=();
	push(@commands,'/security/folder', '-H accept:' . $format);
	my $rs= _do_request(\@commands, {no_result => 1});
	##_debug($rs);
	return $rs;

	return {OK => 1};


}
sub api2_getVanity {
	my %opts = @_;
	my @commands=();
	push(@commands,'/security/folder', '-H accept:' . $format);
	my $rs= _do_request(\@commands, {no_result => 1});
	###_debug($rs);
	return $rs;


}
#'getVanity'	=> {},
#		'getSOA'	=> {},
#		'getZoneAcl'	=> {},
#		'getSecFolder'	=> {},


sub api2_addDomain{
	my(%opts)=@_;
	my @commands=();
	if(exists $opts{debug}){
		$debug = delete $opts{debug};
	}
	my $path = '/dns/managed/';
	if($opts{path}){
		$path = '/dns/' . $opts{path} . "/";
	}
	my %in = %Cpanel::FORM;
	###_debug(\%Cpanel::FORM);return;
	my %post=();
  	my @domains=(); 
	if(exists $in{id} && $in{id}){
		### edit
		$path.=$in{id};
		push(@commands,$path);
		push(@commands,"-X PUT");

	}else{
		### add
		my $domains = $opts{domains};
		$domains=~ s/\r//sg;
		@domains = split(/\n+/,$domains);
		%post=(names => \@domains);

		push(@commands,$path);
		push(@commands,"-X POST");

	}
	foreach(qw/templateId vanityId gtdEnabled soaId transferAclId folderId ipSetId/){
		$post{$_} = $in{$_} if $in{$_};
	}
	$post{gtdEnabled} and $post{gtdEnabled}='true';

	push(@commands, '-H accept:' . $format);
	push(@commands,"-H content-type:$outformat");
	my $json =  _parse_data_out(\%post,$format) ;
	push(@commands,"-d '$json'");
	###print join("<br>",@commands);##return;
	my $rs= _do_request(\@commands, {no_result => ''});
##	_debug($rs);
	## not error
	unless($rs->{error} or $opts{noupdate_named_conf}){
		unless($in{id}){

			foreach(@domains){
				next unless /^\w+/;
				print STDERR "\nupdate_named_conf:$_" if $debug==9;
				_update_named_conf2($_);
			}
		}
	

	}
	return $rs;

}


sub api2_delDomain{

	my(%opts)=@_;

	my @commands=();
	##my $api = api2_getKeys();
#	unless(exists $opts{id}){
#		_error("Domain id must provide");
#		return;
#	}

	my $path = 'managed';
	my $delcmd = 'delAll';
	if($opts{path}){
		$path=$opts{path};
	}
	my $cmd = "/dns/$path";
	if($opts{id}){
		$cmd.="/$opts{id}";
		$delcmd.="/$opts{id}";
	}

	push(@commands,"$cmd");

	push(@commands, '-H accept:' . $format, '-X DELETE');

	my $rs= _do_request(\@commands, {no_result => '', cmdx => $delcmd});
	##&_debug($rs) if $debug==9;
	return $rs;
}

sub api2_domainRecords{

	my(%opts)=@_;
	my $id = delete $opts{id} if exists $opts{id};
	unless($id){
		_error("domin id must provider");
		return {};

#		### get one from its domains and get the first one
#		my $rs = api2_getDomain();
#		$id = $rs->{data}->[0]->{id};
	}

	###https://cp.v2.sandbox.dnsmadeeasy.com/dns/managed/861958/records?type=A&_search=false&nd=1374070995935&rows=10&page=1&sidx=name&sord=asc&_=1374070995936
#	unless($id){
#		_error("Three is no domain listed yet.");
#		return {};
#	}
	## if domain, query its??
	my $t = time;
	my $t2 = $t+1;
	my $path = qq|/dns/managed/$id/records|;
	if($opts{typeid}){
		##$path.="/$opts{typeid}";
	}
	$path.=qq|?type=$opts{type}&_search=true&nd=$t&rows=10&page=1&sidx=name&sord=asc&_=$t2|;

	my @commands=();
	push(@commands,$path, '-H accept:' . $format);

	my $rs= _do_request(\@commands, {no_result => 0});
	#&_debug($rs) if $debug ;#eq 'debug';
	return $rs->{data} if(exists $rs->{data});

	return $rs;



}



sub _do_request{
	my($comandref,$opts,@comands)=@_;
	@comands = @$comandref;
	my $time =time() ;
	my $requestDate = time2str($time);
	#print "\nDate:$requestDate vs $time\n" if $debug;

	### how to get the keys now???
	my $keys = &api2_getKeys(usertheme => 'path to user frontend + theme + "dnsmeapi"');

	my $hmac;
	if($use_external_hmac){
		my $cmd = "/usr/local/cpanel/Cpanel/hmac_date.pl '$requestDate' '$keys->{secretKey}'";
		##print $cmd if $debug;
		$hmac=`$cmd`;
		#$logger->die("\nhmac:$hmac");

		###print "\nhmac:$hmac:" if $debug;

	}else{
		#use Digest::HMAC_SHA1 qw(hmac_sha1_hex);
		$hmac= hmac_sha1_hex($requestDate, $keys->{secretKey});
	}

	my $apiKeyHeader = "x-dnsme-apiKey:" . $keys->{apiKey};
	my $hmacHeader = "x-dnsme-hmac:" . $hmac;
	my $requestDateHeader = "x-dnsme-requestDate:" . $requestDate;

	### include api url??
	##$comands[0]='"' . $keys->{apiURL}  . $comands[0] . '"';
	### del all domains must use the live api url
	if(exists $opts->{cmdx} && $opts->{cmdx} eq 'delAll'){
		##$comands[0]=~ s/sandbox\.//;
		##https://api.dnsmadeeasy.com/V2.0
		$comands[0]='"' . $apiurl . $comands[0] . '"';
	}else{
		$comands[0]='"' . $keys->{apiURL}  . $comands[0] . '"';
	}
	#push(@comands,'-I -w "%{http_code}"');
	push(@comands,'-i') if $debug eq 'returned_status';

	my $url ='';## shift @comands;
#	# run curl with the DNS Made Easy API headers
	my $cmd = qq|$curl | . join (" ", @comands). qq| -H "$apiKeyHeader" -H "$hmacHeader" -H "$requestDateHeader"|;
	print STDERR "\ncmd:$cmd:" if $debug eq "9";
	my $rs = `$cmd` ;

	##_debug($rs);

#	if ($? == -1) {
#        $error = "failed to execute: $!\n";## if $self->{debug};
#    }
#    elsif ($? & 127) {
#        $error = "child died with signal %d, %s coredump\n",
#            ($? & 127),  ($? & 128) ? 'with' : 'without' ;###if $self->{debug};
#    }
#    else {
#        $error = "child exited with value %d\n", $? >> 8;### if $self->{debug};
#    }

	if($opts->{no_result}){
		return {result => $rs};
	}

	return _parse_result($rs);

}

sub _parse_data_out{
	my($data,$format)=@_;
	if($outformat=~ /json/){
		###use Cpanel::JSON ();
		##return Cpanel::JSON::SafeDump($data);
		return JSON::Syck::Dump($data);
	}
	return XML::Simple::XMLout($data);
}
sub _parse_data_in{
	my($data,$ret)=@_;
	if($format=~ /json/){
		##use Cpanel::JSON ();
		##return Cpanel::JSON::Load($data);
		eval{
		$ret= JSON::Syck::Load($data);
		};
		if(@$){
			$ret->{error} = $@;
		}
		return $ret;
	}
	return XML::Simple::XMLin($_[0]);
	###return Cpanel::JSON::Load($_[0]);
}

sub _parse_result{
	### user parse xml
	##$logger->die('got raw:' . $_[0]);
	print "\nResult:$_[0]" if $debug==10;
	my ($rs)=@_;
	if($rs =~ m#<title>([^<]+)</title>#si){

		my $error = $1;
		_error($error);
		return {error => $error};

	}elsif($rs =~ m#Can not#si){
		my $error = $rs;
		_error($error);
		return {error => $error};

	}

	my $rs = _parse_data_in($_[0]);
	unless(defined $rs and keys(%$rs)){
		if($_[0]){

			_error($_[0]);
			$rs->{error} = $_[0];
		}
	}elsif( ref($rs) eq 'HASH' && exists $rs->{error}){
		_error(join (" " , @{$rs->{error}}));
	}


	return $rs;

}

1;

=cut

use DNSmeapi;

my $newmeapi = DNSmeapi->new({apiKey => 'xxx, secretKey => 'yyy', apiurl => 'api.sandbox.dnsmadeeasy.com'});



#sub new{
#	my($self,$opts)=@_;
#
#	my $class={};
#
#
#	bless $class, $self;
#	#$class->get_keys;
#	my %defs = (
##apiKey => '',
##secretKey => '',
#apiurl	=> 'api.dnsmadeeasy.com',
#debug	=> ''
#		);
#	foreach(keys %defs){
#		$class->{$_} = exists $opts->{$_}?$opts->{$_}:$defs{$_};
#	}
#
##	unless($class->{apiKey} and $class->{secretKey}){
##		 die "Missing values for apiKey or secretKey properties";
##	}
#
#	return $class;
#}
